call plug#begin('~/.vim/plugged')

" % works on language specific keywords
Plug 'andymass/vim-matchup'

" Accept .editorconfig
Plug 'editorconfig/editorconfig-vim'

" Airline style status bar
Plug 'vim-airline/vim-airline'
Plug 'vim-airline/vim-airline-themes'

" Highlight and fix trailing whitespace
Plug 'ntpeters/vim-better-whitespace'

" Yank History Cycling on meta-[shift]-p
Plug 'maxbrunsfeld/vim-yankstack'

" Auto indent
Plug 'yggdroot/indentline'

" Update folding less often
Plug 'Konfekt/fastfold'

" Use FZF for browsing vim buffers
Plug 'junegunn/fzf.vim'

" Markdown support
Plug 'plasticboy/vim-markdown'

" Window resizing c-w [<>-+=_|]
Plug 'roxma/vim-window-resize-easy'

" Regex highlighting and in buffer live replacement
" Plug 'markonm/traces.vim'

" Better comments
Plug 'scrooloose/nerdcommenter'

" Session Management
Plug 'tpope/vim-obsession'

" Work on brackets in pairs
Plug 'jiangmiao/auto-pairs'
Plug 'tpope/vim-surround'

" NERDtree + Plugins
Plug 'scrooloose/nerdtree'
Plug 'jistr/vim-nerdtree-tabs'
Plug 'Xuyuanp/nerdtree-git-plugin'
Plug 'ryanoasis/vim-devicons'

" Compilers
Plug 'xuhdev/singlecompile'

" Autocomplete
Plug 'neoclide/coc.nvim', {'branch': 'release'}
Plug 'honza/vim-snippets'

" Language Specific stuff (Language Plugins, Linters, etc)
" Asynchronous lint engine
Plug 'dense-analysis/ale'
Plug 'tpope/vim-endwise'

" Python
Plug 'hdima/python-syntax'
Plug 'fs111/pydoc.vim'
Plug 'Vimjas/vim-python-pep8-indent'
Plug 'tmhedberg/SimpylFold'

Plug 'vim-scripts/javacomplete'
Plug 'udalov/kotlin-vim'
Plug 'xuhdev/vim-latex-live-preview'
Plug 'pearofducks/ansible-vim'
Plug 'justinmk/vim-syntax-extra'

" Rust
Plug 'timonv/vim-cargo'
Plug 'rust-lang/rust.vim'

" DevOps
Plug 'cespare/vim-toml'
Plug 'mrk21/yaml-vim'
Plug 'hashivim/vim-terraform'
Plug 'pedrohdz/vim-yaml-folds'

" KIT-Color-Scheme
Plug 'rad4day/kit.vim' " Original by taDachs <3 if you read this I may owe you a kœri

Plug 'altercation/vim-colors-solarized'


" Git integration
Plug 'braxtons12/blame_line.nvim'
Plug 'airblade/vim-gitgutter'
Plug 'tpope/vim-fugitive'

" Plug 'godlygeek/tabular'
Plug 'plasticboy/vim-markdown'

Plug 'majutsushi/tagbar'
Plug 'rad4day/vim-ripgrep'

Plug 'github/copilot.vim'

" Fancy buffer handling
Plug 'akinsho/bufferline.nvim', { 'tag': 'v2.2.1' }
Plug 'johann2357/nvim-smartbufs'


call plug#end()

